{{

  Simple sample player object
  6x oversampling, noise shaping, 8bit DAC on duty counter

  Piotr Kardasz pik33@o2.pl
  Plays a 512 16-bit stereo samples buffer in endless loop
  v.0.5 beta - 20120716

  Not suitable for overclocking now - delays and oversample factor has to be computed from clkfreq
}}


  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000

  _SD_DO = 0
  _SD_CLK = 1
  _SD_DI = 2
  _SD_CS = 3
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.

VAR

  long cog
  long buf[512]
  long bufnum


obj

fat :   "kyefat_lfn"

pub demo | i

fat.FATEngineStart(_SD_DO, _SD_CLK, _SD_DI, _SD_CS, _SD_WP, _SD_CD, -1, -1, -1)
i:=fat.mountpartition(0)
start(11,10)
'buf:=sample.getbuf

repeat
  fat.openfile(string("wav.wav"),"R")
  repeat
    repeat until bufnum>1024
    i:=fat.readdata(@buf,1024)
    repeat until bufnum<1024
    i:=fat.readdata(@buf+1024,1024)
  until i<>1024


pub getbuf
return @buf

pub getbufnum
return bufnum


PUB start(left, right)

longfill(@buf,0,512)
bufptr:=@buf
stop


leftcounter := ((left & $1F) + constant(%00110 << 26))
rightcounter := ((right & $1F) + constant(%00110 << 26))
outputmask := |<left | |<right

cog:=1+cognew(@init, @bufnum)
return cog
  

PUB stop

if cog>0
  cogstop(cog-1)
cog := 0
  

DAT
                        org     0

init                    mov     ctra,leftcounter
                        mov     ctrb,rightcounter
                        mov     dira,outputmask
                        mov     bufptr2,par
                        mov     time,cnt
                        add     time,delay

loop                    mov     ptr,bufptr
                        add     ptr,bufcnt
                        rdword  lsample,ptr
                        shl     lsample,#16
                        add     ptr, #2
                        rdword  rsample,ptr
                        sar     lsample,#16
                        shl     rsample,#16
                        sar     rsample,#16
                        add     bufcnt,#4
                        and     bufcnt,bufmask
                        mov     over,#6
                        wrlong  bufcnt,bufptr2


p2                      add     i1l,lsample
                        add     i2l,i1l
                        mov     topl,i2l
                        sar     topl,#8
                        mov     fbl,topl
                        shl     fbl,#8
                        sub     i1l,fbl
                        sub     i2l,fbl


                        add     i1r,rsample
                        add     i2r,i1r
                        mov     topr,i2r
                        sar     topr,#8
                        mov     fbr,topr
                        shl     fbr,#8
                        sub     i1r,fbr
                        sub     i2r,fbr

                        maxs    topr, maxval
                        mins    topr, minval
                        add     topr, #$80
                        and     topr, #$FF
                        maxs    topl, maxval
                        mins    topl, minval
                        add     topl, #$80
                        and     topl, #$FF

                        shl     topr, #24
                        shl     topl, #24

                        or      topl,a
                        or      topr,a

                        waitcnt time, #46
                        mov     frqa, a8000
                        mov     frqb, a8000

                        waitcnt time, #256
                        mov     frqa, topr            ' Output.
                        mov     frqb, topl            ' Output.

                        djnz    over,#p2
                        jmp    #loop

leftcounter             long    0
rightcounter            long    0
outputmask              long    0

time                    long 0
delay                   long 256
lsample                 long 0
rsample                 long 0
bufmask                 long %0000_0000_0000_0000_0000_0111_1111_1111
ptr                     long 0
temp                    long 0

bufptr                  long 0
bufcnt                  long 0
bufptr2                 long 0

over                    long 0
topl                    long 0
topr                    long 0
fbl                     long 0
fbr                     long 0
i1r                     long 0
i1l                     long 0
i2l                     long 0
i2r                     long 0
maxval                  long 127
minval                  long -127
a8000                   long $80FF_FFFF
a                       long %0000_0000_1111_1111_1111_1111_11111111


                        fit     496

{{

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}
